// 12/23/96 designed by Dee M. Patel and C. Edward Chow
//          implemented by Dee M. Patel
// Free to use for education and research purpose
// Acknowledge the authors in the code you develop with this
// Given us your feedback at chow@quandary.uccs.edu, dmpatel@sanluis.uccs.edu
//

import java.awt.*;
import java.util.*;
import java.net.*;
import java.io.*;

public class Javadraw extends Frame
{
    //The   Image   used   to   create   the   graphics.   
    protected   Image   img;

    //The   Dimension   of   the   screen
    protected  Dimension   dim;

    //The  Graphic  content  of  the  screen
    protected  Graphics  gra;

    //The  width  and  height  of  the  screen
    protected  int  wdth;
    protected  int  hght;

    //Local  values
    //The  previous  x-coordinate  and  y-coordinate.
    protected  int  l_lastx;
    protected  int  l_lasty;
    protected  int  l_penthickness;      //set  pen  thickness
    protected  int  l_erasethickness;    //set  erase  thickness
    protected  int  l_color;
    protected  int  l_lasttype;
    protected  int  l_keyx;
    protected  int  l_keyy;
    protected  String l_name;
    protected  char l_style;
    protected  int  l_size;

    //Remote  values
    //The  previous  x-coordinate  and  y-coordinate.
    protected  int  r_x;
    protected  int  r_y;
    protected  int  r_lastx;
    protected  int  r_lasty;
    protected  int  r_penthickness;      //set  pen  thickness
    protected  int  r_erasethickness;    //set  erase  thickness
    protected  int  r_color;
    protected  int  r_lasttype;
    protected  String r_name;
    protected  char r_style;
    protected  int  r_size;

    getdis		gdis;
    connect_dialog	c_diag;
    Still_Connected     still_connected;
    list_dialog		l_diag;
    show_list 		s_list;
    String 		id_name;
    String 		conf_name;
    String		ipaddress  =  null;

    //Determines  whether  the  first  point  has  been  added  to  the  screen
    protected  boolean  gotFirstPoint;

    //Determines  whether  the  screen  needs  to  be  updated.
    protected  boolean  updateDisplay;

    // Network and Socket variables
    //public  Socket  socket  =  null;
    DataInputStream   dis  =  null;
    DataOutputStream  dos  =  null;
    boolean text_mode = false;
    int width_increment = 0;

    protected boolean connected = false;

    //TEXT FIELDS
    TextField idtxt;
    TextField iptxt;
    TextField porttxt;
    TextField conftxt;
    TextField msgtxt;
    TextField infotxt;

    //LABEL
    Label iplbl;
    Label portlbl;
    Label conflbl;
    Label msglbl;

    //BUTTONS
    Button penbtn;
    Button textbtn;
    Button erasebtn;
    Button cleanbtn;
    Button connectbtn;
    Button disconnectbtn;
    Button conferencebtn;

    //Window size;
    int win_x = 600;
    int win_y = 400;


    //METHODS
    public Javadraw()
    {
        super  ("JAVADRAW - By Dee Patel");
        return;
    }
    public void tests(int count)
    {
        System.out.println("***COUNT= " + count);
    }
    public void runJavadraw()
    {
        setLayout(new BorderLayout());
        Panel north = new Panel();
	GridBagLayout gridbag = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
        Insets insets = new Insets(3,0,0,2);
        c.insets = insets;
        north.setLayout(gridbag);
        c.anchor = GridBagConstraints.CENTER;
        c.weightx = 0.0;
        c.gridwidth = 1;
        penbtn = makebutton(penbtn, "PEN", north, gridbag, c);
        textbtn = makebutton(textbtn, "TEXT", north, gridbag, c);
        erasebtn = makebutton(erasebtn, "ERASER", north, gridbag, c);
        cleanbtn = makebutton(cleanbtn, "CLEAN", north, gridbag, c);
        connectbtn = makebutton(connectbtn, "CONNECT", north, gridbag, c);
        disconnectbtn = makebutton(disconnectbtn, "DISCONNECT", north, gridbag, c);
        conferencebtn = makebutton(conferencebtn, 
           "CONFERENCE MANAGEMENT", north, gridbag, c);
        add("North", north);

        Panel south = new Panel();
        south.setLayout(new FlowLayout(FlowLayout.LEFT));
        msglbl = new Label("Message:");
        south.add(msglbl);
        msgtxt = new TextField(25);
        msgtxt.setEditable(false);
        south.add(msgtxt);
        infotxt = new TextField(30);
        infotxt.setEditable(false);
        south.add(infotxt);
        add("South", south);

        resize(win_x, win_y);
        setBackground(Color.white);

        //serveripaddress = ipaddress;
        //port  =  new  Integer(strport).intValue();

        makeMenus();
        show();
        init();
        //sendtoscreen_fromremote();
    }

    Button makebutton(Button button,
                    String name,
                    Panel area,
		    GridBagLayout gridbag, 
		    GridBagConstraints c)
    {
        button = new Button(name);
        gridbag.setConstraints(button, c);
        area.add(button);
        return button;
    }

    private  void  makeMenus()  
    {
        MenuBar  mb  =  new  MenuBar();

	Menu mp = new Menu("Pen Thickness");
        mp.add (new MenuItem("1 ppx"));
        mp.add (new MenuItem("2 ppx"));
        mp.add (new MenuItem("3 ppx"));
        mp.add (new MenuItem("4 ppx"));
        mp.add (new MenuItem("5 ppx"));
        mp.add (new MenuItem("6 ppx"));
        mp.add (new MenuItem("7 ppx"));
        mp.add (new MenuItem("8 ppx"));
        mp.add (new MenuItem("9 ppx"));

	Menu me = new Menu("Erase Thickness");
        me.add (new MenuItem("1 epx"));
        me.add (new MenuItem("2 epx"));
        me.add (new MenuItem("3 epx"));
        me.add (new MenuItem("4 epx"));
        me.add (new MenuItem("5 epx"));
        me.add (new MenuItem("6 epx"));
        me.add (new MenuItem("7 epx"));
        me.add (new MenuItem("8 epx"));
        me.add (new MenuItem("9 epx"));

	Menu mfname = new Menu("Name");
        mfname.add (new MenuItem("TimesRoman"));
        mfname.add (new MenuItem("Helvetica"));

	Menu mfstyle = new Menu("Style");
        mfstyle.add (new MenuItem("PLAIN"));
        mfstyle.add (new MenuItem("BOLD"));
        mfstyle.add (new MenuItem("ITALIC"));

	Menu mfsize = new Menu("Size");
        mfsize.add (new MenuItem("12 pt"));
        mfsize.add (new MenuItem("14 pt"));
        mfsize.add (new MenuItem("16 pt"));
        mfsize.add (new MenuItem("18 pt"));
        mfsize.add (new MenuItem("20 pt"));
        mfsize.add (new MenuItem("22 pt"));
        mfsize.add (new MenuItem("24 pt"));
        mfsize.add (new MenuItem("26 pt"));
        mfsize.add (new MenuItem("28 pt"));
        mfsize.add (new MenuItem("30 pt"));
        mfsize.add (new MenuItem("34 pt"));
        mfsize.add (new MenuItem("38 pt"));

        Menu  mf  =  new  Menu("File");
        mf.add(  new  MenuItem("Quit")  );

        Menu  mt  =  new  Menu("Tools");
        mt.add(mp);
        mt.add(me);

        Menu  mfont  =  new  Menu("Font");
        mfont.add(mfname);
        mfont.add(mfstyle);
        mfont.add(mfsize);

        mb.add(mf);
        mb.add(mt);
        mb.add(mfont);
        setMenuBar(mb);
    }

    //Initialization  of  the  screen  Applet
    public  void  init()  
    {
        c_diag = new connect_dialog(this);
        c_diag.get_sdraw(this);
        l_diag = new list_dialog(this);
        l_diag.get_sdraw(this);
	still_connected = new Still_Connected(this);
        s_list = l_diag.get_sl();
        dim  =  size();
        wdth  =  dim.width;
        hght  =  dim.height;

        l_lastx  =  0;        
        l_lasty  =  0;
        l_penthickness  =  0;
        l_erasethickness  =  5;
        l_lasttype  =  0;
        l_color  =  0;
        l_keyx   = 0;
        l_keyy   = 0;
        l_name   = "TimesRoman";
        l_style  = 'P';
        l_size   = 16;

        r_lastx  =  0;        
        r_lasty  =  0;
        r_penthickness  =  0;
        r_erasethickness  =  5;
        r_lasttype  =  0;
        r_color  =  0;
        r_name   = "TimesRoman";
        r_style  = 'P';
        r_size   = 16;

        //Erasex  =  20;
        //Erasey  =  h  -  25;
        gotFirstPoint  =  false;
        updateDisplay  =  true;

        disconnectbtn.disable();
        //connect_client();
    }  //init()

    public void disconnect_client()
    {
        if(!connected)
        {
            return;
        }
       
            //dos.writeBytes("close"+" "+id_name+"\n");
            //dos.flush();
            disconnectbtn.disable();
            connectbtn.enable();
            infotxt.setText(" ");
            gdis.update_dis(null,null,null);
            gdis.stop();
            id_name = null;
            conf_name = null;
            ipaddress = null;
            connected = false;
    }
    public void update_dosdis(DataOutputStream cdos,
                              DataInputStream  cdis,
                              String id_nm,
                              String conf_nm,
                              String ip_add)
    {
        dos = cdos;
        dis = cdis;
        id_name = id_nm;
        conf_name = conf_nm;
        ipaddress = ip_add;
        connected = true;

        infotxt.setText(id_name+" "+conf_name+" "+" "+ipaddress);
        disconnectbtn.enable();
        connectbtn.disable();
        
        gdis = new getdis();
        gdis.get_sdraw(this);
        gdis.update_dis(dis,conf_nm,id_nm);

            gdis.start();
        /*
        boolean talive = gdis.isAlive();
        if(talive == true)
        { 
            gdis.resume();
        }
        else
        {
            gdis.start();
        }*/
    }
    
    synchronized void getdis_list(String[] str, int max_index)
    {        
        s_list.clear();
        s_list.update_list(str, max_index);
    } 
    synchronized boolean getdis_pen(int g_lastx,
                           int g_lasty,
                           int g_x,
                           int g_y,
                           int g_penthickness,
                           int g_erasethickness,
                           int g_color)
    {
        r_lastx = g_lastx;
        r_lasty = g_lasty;
        r_x = g_x;
        r_y = g_y;
        r_penthickness = g_penthickness;
        r_erasethickness = g_erasethickness;
        r_color = g_color;
        
        remote_addScreenPoint(r_lastx, 
                              r_lasty, 
                              r_x, 
                              r_y, 
                              r_penthickness, 
                              r_erasethickness, 
                              r_color);
         repaint();
         return true;
     }

     synchronized boolean getdis_text(int g_x,
                             int g_y,
                             String g_name,
                             char g_style,
                             int g_size,
                             int g_int)
     {
            r_x  = g_x;
            r_y  = g_y;
            r_name  = g_name;
            r_style  = g_style;
            r_size  =  g_size;
            int temp_int  = g_int;
        
            remote_texttoscreen((char) temp_int);
            repaint();
            return true;
      }


    public  void  paint(Graphics  g)  {  
        update(g);  
    }

    public  void  update(Graphics  ig)  
    {
        Dimension  udim = size();
        if  ((img  ==  null)  ||
             (udim.width  !=  dim.width)  ||
             (udim.height  !=  dim.height))
	{
            wdth  =  udim.width;
            hght  =  udim.height;  
            //Erasey  =  h  -  25;
            img  =  createImage(wdth,hght);
            dim  =  udim;
            gra  =  img.getGraphics();
            updateDisplay  =  true;
        }  
        if(updateDisplay  ==  true)  
	{
            //  Draw  the  blue  frame  ect.
            drawScreen();
            updateDisplay  =  false;
        }

        //  Draw  the  image
        ig.drawImage(img,  0,  0,  null);      
        //  showStatus("Written  by  Dee  Patel");
    }  

    public boolean handleEvent(Event e)
    {
        if(e.id == Event.WINDOW_DESTROY)
        {
	    if(!connected)
	    {
                System.exit(0);
            }
	    else
	    {
	        still_connected.show();
	    }
            return true;
        }
        else
        {
            return super.handleEvent(e);
        }
    }
    public  boolean  action(Event  evt,  Object  obj)
    {
        char thick;
        int  ithick = 0;
        int  text_size = 0;
        if  (evt.target  instanceof  MenuItem)  
        {
            String  label  =  (String)obj;

            if (label.regionMatches(2, "ppx", 0, 3)) 
            {
                thick = label.charAt(0);
                ithick = (int)thick - '0' - 1;
                l_penthickness = ithick;
//                System.out.println("Pen = " + thick + " " + ithick);
            }

            else if (label.regionMatches(2, "epx", 0, 3)) 
            {
                thick = label.charAt(0);
                ithick = (int)thick - '0';
                l_erasethickness = ithick;
//                System.out.println("Erase = " + thick + " " + ithick);
            }

            else if (label.regionMatches(true, 0, "TimesRoman", 0, label.length())) 
            {
                l_name = label;
            }

            else if (label.regionMatches(true, 0, "Helvetica", 0, label.length())) 
            {
                l_name = label;
            }

            else if (label.regionMatches(true, 0, "PLAIN", 0, label.length()) ||
                     label.regionMatches(true, 0, "BOLD", 0, label.length()) ||
                     label.regionMatches(true, 0, "ITALIC", 0, label.length())
                    ) 
            {
                l_style = label.charAt(0);
            }

            else if (label.regionMatches(3, "pt", 0, 2)) 
            {
                l_size = new Integer(label.substring(0,2)).intValue();  
            }

            else if  (label.equals("Quit"))  
            {
                //send_data_to_server("close"+" "+ipaddress);
                //disconnect_client();
		if(!connected)
		{
                    System.exit(0);
                }
		else
		{
		    still_connected.show();
		}
            }
        }
        else  if(evt.target  instanceof  Button)
	{
            gotFirstPoint  =  false;
            String  label  =  (String)obj;
            if  (label.equals("PEN"))
	    {
                display_error_warning("PEN MODE");
                l_color  =  1;
                text_mode = false;
            }
            else  if  (label.equals("CLEAN"))
	    {
                display_error_warning("CLEAN SCREEN");
                gotFirstPoint  =  true;
                local_addScreenPoint(l_lastx, 
                                     l_lasty,
                                     l_lastx,
                                     l_lasty,
                                     l_penthickness,
                                     l_erasethickness,
                                     3); 
                text_mode = false;
                repaint();
            }
            else  if  (label.equals("TEXT"))
	    {
                display_error_warning("TEXT MODE");
                text_mode = true;
            }
            else  if  (label.equals("ERASER"))
	    {
                display_error_warning("ERASER MODE");
                l_color  =  2;
                text_mode = false;
            }
            else  if  (label.equals("CONNECT"))
	    {
                display_error_warning("CONNECT MODE");
                c_diag.show();
            }

            else if  (label.equals("DISCONNECT"))  
            {
                display_error_warning("DISCONNECT MODE");
                send_data_to_server("close"+" "+ipaddress);
                disconnect_client();
                return  true;
            }
            else  if  (label.equals("CONFERENCE MANAGEMENT"))
	    {
                display_error_warning("CONFERENCE MANAGEMENT MODE");
                l_diag.revoketxt.setText(" ");
                l_diag.show();
            }

            else  
	    {
                l_color  =  0;
                text_mode = false;
            }
        }
        return  true;
    }

    public void revoke_client(String command,
                              String revoke_name,
                              String revoke_time)
    {
        if((command.length() == 0) ||
           (revoke_time.length() == 0) ||
           (revoke_time.length() == 0)
          )
        {
            return;
        }
        send_data_to_server(command + " " +
                            ipaddress + " " +
                            revoke_time + " " +
                            revoke_name);
    }

    public  void  drawScreen()  
    {
        //  Set  the  color  to  Light  Gray
        gra.setColor(Color.white);

        //  Fill  entire  applet  with  gray                        
        gra.fillRect(0,30,wdth,hght);
    }

    public  boolean  keyUp(Event evt, int Key)
    {
        char c_key;

        c_key = (char) Key;
        //System.out.println("char = " + c_key + " " + Key);
        local_texttoscreen(c_key);
        return false;
    }

    public  boolean  mouseDown(Event  evt,  int  x,  int  y)  
    {
        if((x  >  1  &&  x  <  wdth  -  1)  &&
           (y  >  30  &&  y  <  hght  -  1) &&
           !text_mode
          )
	{  
            //int  color  =  1;    
            local_addScreenPoint(l_lastx, 
				 l_lasty, 
				 x,  
				 y, 
				 l_penthickness, 
				 l_erasethickness, 
				 l_color);
            repaint();
            //erasing  =  false;
            return  true;
        }
        return  false;
    }

    public  boolean  mouseDrag(Event  evt,  int  x,  int  y)  
    {
        //  If  erasing  then  continue  to  erase  with  the  drag  event
        //  If  draging  inside  drawing  area  then  draw
        if((x  >  1  &&  x  <  wdth  -  1)  &&
           (y  >  30  &&  y  <  hght  -  1) &&
           !text_mode
          )
	{
            //drawing  =  type  1
            //int  color  =  1;    
            local_addScreenPoint(l_lastx, 
				 l_lasty, 
				 x,  
				 y, 
				 l_penthickness, 
				 l_erasethickness, 
				 l_color);
            repaint();
            //erasing  =  false;
            return  true;
        }
        return  false;
    }

    public  boolean  mouseUp(Event  evt,  int  x,  int  y)  
    {
        //System.out.println ("text_mode = " +text_mode);
        if (text_mode)
        {
            l_keyx = x;
            l_keyy = y;
            //texttoscreen (x, y, "TimesRoman", 'P', 36, 'C');
        }
        else
        {
            local_addScreenPoint(l_lastx, 
                                 l_lasty, 
                                 x,  
                                 y, 
                                 l_penthickness, 
                                 l_erasethickness, 
                                 l_color);
        }
        width_increment = l_keyx;
//System.out.println("x= " + x + " y= "+ y);
        repaint();
        //erasing  =  false;
        return  true;        
    }

    public  void  local_addScreenPoint(int llx, 
				       int lly, 
                                       int x,  
				       int y, 
				       int l_pen, 
				       int l_erase,  
				       int l_colortype) 
    {
        if (connected == true)
        {
            senddata (llx, lly, x, y, l_pen, l_erase, l_colortype);
        }
        addScreenPoint(llx, lly, x, y, l_pen, l_erase, l_colortype, l_lasttype);
        l_lastx  =  x;
        l_lasty  =  y;
        l_lasttype = l_colortype;
    }

    synchronized  void  remote_addScreenPoint(int llx, 
                                        int lly, 
                                        int x, 
                                        int y, 
                                        int r_pen, 
                                        int r_erase, 
                                        int r_colortype) 
    {
        addScreenPoint(llx, lly, x, y, r_pen, r_erase, r_colortype, r_lasttype);
        r_lastx  =  x;
        r_lasty  =  y;
        r_lasttype = r_colortype;
    }

    public void sendtext(int text_x, 
                         int text_y,
                         char char_to_print 
                        )
    {
        int temp_char_int = 0;
      
	if(!connected)
	{
	    return;
	}
        temp_char_int = (int) char_to_print;
            send_data_to_server("T" + " " +
                                text_x + " " +
                                text_y + " " +
                                l_name + " " +
                                l_style + " " +
                                l_size + " " +
                                temp_char_int
                               );
            //dos.flush();
    }

    public void senddata(int llx, 
                         int lly,
                         int x,
                         int y,
                         int l_pen, 
                         int l_erase,  
                         int l_colortype 
                        )
    {
	if(!connected)
	{
	    return;
	}
            //display_error_warning("Sending PEN INFO");
            send_data_to_server("P" + " " +
                           llx + " " +
                           lly + " " +
                           x     + " " +
                           y     + " " +
                           l_pen + " " +
                           l_erase + " " +
                           l_colortype
                           );
            //dos.flush();
    }
      
    public void remote_texttoscreen(char char_to_print)
    {
        Font text_font;
        String tmp_str = null;
        char[] printchar;
        int x;

        if((char_to_print >= ' ') &&
           (char_to_print <= '~')
          )
        {
            tmp_str = String.valueOf(char_to_print);
            printchar = tmp_str.toCharArray();
            if (r_style == 'B')
            {
                text_font = new Font(r_name, Font.BOLD, r_size);
            }
            else if (r_style == 'I')
            {
                text_font = new Font(r_name, Font.ITALIC, r_size);
            }
            else
            {
                text_font = new Font(r_name, Font.PLAIN, r_size);
            }
            gra.setFont(text_font);
            gra.setColor(Color.black);

            texttoscreen (r_x,
                          r_y,
                          printchar);
        }
    }
      
    public void local_texttoscreen(char char_to_print)
    {
        Font text_font;
        String tmp_str = null;
        char[] printchar;
        int char_width = 0;
        int x;

        if((char_to_print >= ' ') &&
           (char_to_print <= '~')
          )
        {
            tmp_str = String.valueOf(char_to_print);
            printchar = tmp_str.toCharArray();
            if (l_style == 'B')
            {
                text_font = new Font(l_name, Font.BOLD, l_size);
            }
            else if (l_style == 'I')
            {
                text_font = new Font(l_name, Font.ITALIC, l_size);
            }
            else
            {
                text_font = new Font(l_name, Font.PLAIN, l_size);
            }
            gra.setFont(text_font);
            gra.setColor(Color.black);
            FontMetrics fm = getFontMetrics(getFont());
            char_width = fm.charsWidth(printchar, 0, 1);

            texttoscreen (width_increment,
                          l_keyy,
                          printchar);
            if (connected == true)
            {
                sendtext (width_increment,
                          l_keyy,
                          char_to_print);
            }
            width_increment = width_increment + char_width;
        }
    }

    public  void  texttoscreen (int tx, 
                                int ty,
                                char[] printchar)
    {
        gra.drawChars(printchar, 0, 1, tx, ty);
        repaint();
    }

    synchronized  void  addScreenPoint(int llx, 
				 int lly, 
				 int x, 
				 int y, 
				 int pen_thick,
				 int erase_thick,
				 int color_type,
                                 int lasttype)  
    {
        if(gra == null)
        {
            System.out.println("NO GRAPHICS");
            return;
        }
        int  thickness = 0;        //initialization
      
        if(gotFirstPoint  ==  true  &&  (lasttype  !=  0))  
	{
            switch(color_type)  
	    {
                case  1:
                    gra.setColor(Color.black);
                    gra.drawLine(llx,  lly,  x,  y);
                    for (thickness  =  1;  
                         (thickness  <  10)  &&  (thickness  <=  pen_thick);  
                         thickness++
                        )
                    {
                        gra.drawLine(llx+thickness,  
                                     lly+thickness,
                                     x+thickness,  
                                     y+thickness);
                        gra.drawLine(llx-thickness,  
                                     lly-thickness,
                                     x-thickness,  
                                     y-thickness);
                        gra.drawLine(llx+thickness,  
                                     lly-thickness,
                                     x+thickness,  
                                     y-thickness);
                        gra.drawLine(llx-thickness,  
                                     lly+thickness,
                                     x-thickness,  
                                     y+thickness);
                    }     
                    break;

                case  2:                      
                    gra.setColor(Color.white);
                    gra.drawLine(llx,  lly,  x,  y);
                    for (thickness  =  1;  
                         (thickness  <  10)  &&  (thickness  <=  erase_thick);  
                         thickness++
                        )
                    {
                        gra.drawLine(llx+thickness,  
                                     lly+thickness,
                                     x+thickness,  
                                     y+thickness);
                        gra.drawLine(llx-thickness,  
                                     lly-thickness,
                                     x-thickness,  
                                     y-thickness);
                        gra.drawLine(llx+thickness,  
                                     lly-thickness,
                                     x+thickness,  
                                     y-thickness);
                        gra.drawLine(llx-thickness,  
                                     lly+thickness,
                                     x-thickness,  
                                     y+thickness);
                    } 
                    break;

                case  3:  //Clean  Screen
                    gra.setColor(Color.white);
                    gra.fillRect(0,0,wdth,hght);
                    break;

                default:                    
                    break;              
            } // End of switch
        } // End of IF STATMENT
        //  Set  the  "last"  variables  for  the  next  call  to  this  function
        //lastx  =  x;
        //lasty  =  y;
        //lasttype  =  color_type;
        gotFirstPoint  =  true;
    }

    public void display_error_warning(String str)
    {
        msgtxt.setText(str);
    }

    public void send_data_to_server(String str)
    {
        if(!connected ||
           (str.length() == 0) ||
           (id_name.length() == 0) ||
           (conf_name.length() == 0) ||
           (dos == null)
          )
        {
            return;
        }
        try
        {
            dos.writeBytes(conf_name+" "+
                           id_name  +" "+
                           str+"\n");
            dos.flush();
        }
        catch(IOException e) 
        {
            System.out.println("ERROR: Writing");
        }
    }

    public  static  void  main  (String  args[])
    {
        Javadraw s = new Javadraw();
        //Javadraw s2 = new Javadraw();
        //s2.tests();
        s.runJavadraw();
    }
}

class list_dialog extends Dialog
{
    show_list s_list;
    static Javadraw s;
    TextField revoketxt;
    TextField tmtxt;

    public void get_sdraw(Javadraw sdraw)
    {
        s = sdraw;
    }

    public show_list get_sl()
    {
        return s_list;
    }
    public list_dialog(Frame parent)
    {
        super(parent, "List of Clients Connected to IS", true);

        setLayout(new BorderLayout());
        s_list = new show_list();
        add("Center",s_list);

        Panel north = new Panel();


        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
        Insets insets = new Insets(2,2,2,2);
        c.insets = insets;

        revoketxt = new TextField(20);
        revoketxt.setEditable(false);
        gridbag.setConstraints(revoketxt, c);
        north.add(revoketxt);


        Label tmlbl = new Label("Revoke Time(Minutes):");
        gridbag.setConstraints(tmlbl, c);
        north.add(tmlbl);

        c.gridwidth = GridBagConstraints.REMAINDER;
        tmtxt = new TextField(4);
        gridbag.setConstraints(tmtxt, c);
        north.add(tmtxt);
        add("North", north);

        Panel south = new Panel();
        c.gridwidth = 1;
        Button suspendbtn = new Button("SUSPEND");
        gridbag.setConstraints(suspendbtn, c);
        south.add(suspendbtn);
        Button revokebtn = new Button("REVOKE");
        gridbag.setConstraints(revokebtn, c);
        south.add(revokebtn);
        Button cancelbtn = new Button("CANCEL");
        gridbag.setConstraints(cancelbtn, c);
        south.add(cancelbtn);

        add("South", south);

        resize(500,200);
        setBackground(Color.lightGray);
        setResizable(true);

        s_list.update_revoketxt(revoketxt);
    }
    public boolean handleEvent(Event e)
    {
        if(e.id == Event.WINDOW_DESTROY)
        {
            hide();
            return true;
        }
        else
        {
            return super.handleEvent(e);
        }
    }
    public boolean action(Event e, Object arg)
    {
        String label = (String)arg;
        if(label.equals("SUSPEND"))
        {
            String tmp_name = revoketxt.getText();
            String revoke_time = tmtxt.getText();
            if(tmp_name.length() != 0 && revoke_time.length() != 0)
            {
                StringTokenizer inputbufferST =
                    new StringTokenizer(tmp_name, " ");
                String revoke_name = inputbufferST.nextToken();
                s.revoke_client("Suspend", revoke_name, revoke_time);
            }
            hide();
        }
        else if(label.equals("REVOKE"))
        {
            //System.out.println("REVOKE "+revoketxt.getText()+" "+tmtxt.getText());
            String tmp_name = revoketxt.getText();
            String revoke_time = tmtxt.getText();
            if(tmp_name.length() != 0 && revoke_time.length() != 0)
            {
                StringTokenizer inputbufferST =
                    new StringTokenizer(tmp_name, " ");
                String revoke_name = inputbufferST.nextToken();
                //System.out.println("REVOKE "+revoke_name+" "+revoke_time);
                s.revoke_client("Revoke", revoke_name, revoke_time);
            }
            hide();
        }
        else if(label.equals("CANCEL"))
        {
            hide();
        }
        return true;
    }
}

class show_list extends List
{
    TextField rtxt;
    public show_list()
    {
        super(4, false);
    }
    public void update_revoketxt(TextField revoketxt)
    {
        rtxt = revoketxt;
    }
    public void update_list(String[] str, int max_index)
    {
        int index = 2;
        while(index < max_index)
        {
            String item = pad_str(str[index++], " ", 25);
            item = item + str[index++];
            addItem(item);
        } 
    }
    public String pad_str(String str, String pad_char, int final_length)
    {
        int index = str.length();
        while(index < final_length)
        {
            str = str + pad_char;
            index++;
        }
        return str;
    }

    
    public boolean handleEvent(Event evt)
    {
        switch(evt.id)
        {
            case Event.LIST_SELECT:
                return listSelect(evt, evt.arg);
            case Event.LIST_DESELECT:
                return listDeselect(evt, evt.arg);
        }
        return false;
    }
    

    public boolean listSelect(Event evt, Object obj)
    {
        //System.out.println("SELECT "+evt.target.toString()+ " "+ obj.toString());
        String tmpstr = getSelectedItem();
        //System.out.println("SELECT "+tmpstr);
        rtxt.setText(tmpstr);
        return true;
    }

    public boolean listDeselect(Event evt, Object obj)
    {
        System.out.println("DESELECT "+evt.toString());
        return true;
    }
}


class connect_dialog extends Dialog
{
    TextField idtxt;
    TextField iptxt;
    TextField porttxt;
    TextField conftxt;
    TextField msgtxt;
    String id_name;
    String conf_name;
    String ipaddress;
    int temp_port;
    boolean connected = false;

    DataInputStream  dis  =  null;
    DataOutputStream  dos  =  null;
    static Javadraw s;

    public void get_sdraw(Javadraw sdraw)
    {
        s = sdraw;
    }

    public connect_dialog(Frame parent)
    {
        super(parent, "Connect To Server Screen", true);

        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();

        Insets insets = new Insets(5,5,5,5);
        c.insets = insets;

        setLayout(gridbag);
        c.anchor = GridBagConstraints.WEST;
        c.gridwidth = 1;
        Label idlbl = new Label("ID/Name:");
        gridbag.setConstraints(idlbl, c);
        add(idlbl);
        c.gridwidth = GridBagConstraints.REMAINDER;
        idtxt = new TextField(20);
        gridbag.setConstraints(idtxt, c);
        add(idtxt);

        c.gridwidth = 1;
        Label iplbl = new Label("IP Address:");
        gridbag.setConstraints(iplbl, c);
        add(iplbl);
        c.gridwidth = GridBagConstraints.REMAINDER;
        iptxt = new TextField(20);
        gridbag.setConstraints(iptxt, c);
        add(iptxt);

        c.gridwidth = 1;
        Label portlbl = new Label("Port:");
        gridbag.setConstraints(portlbl, c);
        add(portlbl);
        c.gridwidth = GridBagConstraints.REMAINDER;
        porttxt = new TextField(20);
        gridbag.setConstraints(porttxt, c);
        add(porttxt);

        c.gridwidth = 1;
        Label conflbl = new Label("Conference:");
        gridbag.setConstraints(conflbl, c);
        add(conflbl);
        c.gridwidth = GridBagConstraints.REMAINDER;
        conftxt = new TextField(20);
        gridbag.setConstraints(conftxt, c);
        add(conftxt);

        c.gridwidth = 1;
        c.anchor = GridBagConstraints.CENTER;
        Button connect_button = new Button("Connect");
        gridbag.setConstraints(connect_button, c);
        add(connect_button);
        c.gridwidth = GridBagConstraints.REMAINDER;
        Button cancel_button = new Button("Cancel");
        gridbag.setConstraints(cancel_button, c);
        add(cancel_button);

        c.anchor = GridBagConstraints.WEST;
        c.gridwidth = 1;
        Label msglbl = new Label("ERROR :");
        gridbag.setConstraints(msglbl, c);
        add(msglbl);
        c.gridwidth = GridBagConstraints.REMAINDER;
        msgtxt = new TextField(30);
        gridbag.setConstraints(msgtxt, c);
        add(msgtxt);

        resize(400,300);
        setBackground(Color.lightGray);
        setResizable(true);
    }
    public boolean handleEvent(Event e)
    {
        if(e.id == Event.WINDOW_DESTROY)
        {
            hide();
            return true;
        }
        else
        {
            return super.handleEvent(e);
        }
    }
    public boolean action(Event e, Object arg)
    {
        String label = (String)arg;
        if(label.equals("Connect") && !connected)
        {
            if(connect_client())
            {
                connected = true;
                s.update_dosdis(dos, dis, id_name, conf_name,ipaddress);
                hide();
            }
            {
                connected = false;
            }
        }
        else if(label.equals("Cancel"))
        {
            hide();
        }
        return true;
    }

    public boolean connect_client()
    {
        //System.out.println ("Connect_client"); 
        String idstr = null;
        String ipstr = null;
        String portstr = null;
        String confstr = null;
        String serveripaddress = null;
        int    port  =  0;
        Socket  socket  =  null;

        idstr = idtxt.getText();
        ipstr = iptxt.getText();
        portstr = porttxt.getText();
        confstr = conftxt.getText();

        if(idstr.length() == 0 ||
           ipstr.length() == 0 ||
           portstr.length() == 0 ||
           confstr.length() == 0)
        {
            //System.out.println("ERROR: connection");
            msgtxt.setText("ID OR IP Address OR port OR Conference is Empty");
            return false;
        }
        else
        {
            serveripaddress = ipstr;
            port = new Integer(portstr).intValue();
            id_name = idstr;
            conf_name = confstr;
        }

        try     
        {
            socket = new Socket(serveripaddress, port);
            System.out.println("Socket" + socket);
            dos = new DataOutputStream(socket.getOutputStream());
            dis = new DataInputStream(socket.getInputStream());
            temp_port = socket.getLocalPort();

            /*
            InetAddress add = socket.getInetAddress();
            temp_port = socket.getLocalPort();

            String ipadd_str = add.toString();
            StringTokenizer inputbufferST =
                new StringTokenizer(ipadd_str,"/");
            String ipadd_str2 = inputbufferST.nextToken();
            ipadd_str2 = inputbufferST.nextToken();
            String ipadd = ipadd_str2+":"+Integer.toString(temp_port);
            ipaddress = ipadd;
            dos.writeBytes(conf_name + " " +
                           id_name + " " +
                           "Connect" + " " +
                           ipadd + " " +
                           "0" + " " +
                           "\n");
            dos.flush();
            connected = true;
            msgtxt.setText("Connected To Server");
            return true;
            */
        }
        catch(IOException  e)
	{
            connected = false;
            //System.out.println("Error:  IO  Exception");
            msgtxt.setText("Error: Cannot Connect to Server");
            return false;
        }

        try
        {
            InetAddress add = null;
            add = InetAddress.getLocalHost();

            String ipadd_str = add.toString();
            StringTokenizer inputbufferST =
                new StringTokenizer(ipadd_str,"/");
            String ipadd_str2 = inputbufferST.nextToken();
            ipadd_str2 = inputbufferST.nextToken();
            String ipadd = ipadd_str2+":"+Integer.toString(temp_port);
            ipaddress = ipadd;
        }
        catch(UnknownHostException e)
        {
            connected = false;
            return false;
        }
        try
        {
            dos.writeBytes(conf_name + " " +
                           id_name + " " +
                           "Connect" + " " +
                           ipaddress + " " +
                           "0" + " " +
                           "\n");
            dos.flush();
            connected = true;
            msgtxt.setText("Connected To Server");
            return true;
        }
        catch(IOException  e)
	{
            connected = false;
            //System.out.println("Error:  IO  Exception");
            msgtxt.setText("Error: Cannot Connect to Server");
            return false;
        }
    }

}

class Still_Connected extends Dialog {

    public Still_Connected(Frame parent) {
        super(parent, "Connection Information Box", true);
        Panel pl = new Panel();
	pl.setLayout(new GridLayout(2,1));
	pl.add(new Label("Client Connected to Server",Label.CENTER));
	pl.add(new Label("Please DISCONNECT Client",Label.CENTER));
        add("Center", pl);
        Panel p = new Panel();
        add("South", p);
        p.add(new Button("OK"));
        resize(250, 100);
        setResizable(true);
    }

    public boolean action(Event e, Object arg) {
        hide();
        return true;
    }
}

